UVA11396-Claw Decomposition(二分图判定)

题目链接

题意:是否能将一张无向连通图分解成多个爪型。每一条边只能属于一个爪型,每个点的度数为3.

思路:当图分解成类干个爪型时,每条边只属于一个爪子,所以每条边的两个点一定要处于2个不同的鸡爪中

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 305;

vector<int> g[MAXN];
int n, color[MAXN];

void init() {
    for (int i = 0; i < n; i++)
        g[i].clear();
}

bool bipartite(int u) {
    for (int i = 0; i < g[u].size(); i++) {
        int v = g[u][i];
        if (color[u] == color[v]) return false;
        if (!color[v]) {
            color[v] = 3 - color[u];
            if (!bipartite(v)) return false;
        }
    }
    return true;
}

int main() {
    while (scanf("%d", &n) && n) {
        init();
        int u, v;
        while (scanf("%d%d", &u, &v)) {
            if (u == 0 && v == 0)
                break;
            u--;
            v--;
            g[u].push_back(v);
            g[v].push_back(u);
        }

        memset(color, 0, sizeof(color));
        color[0] = 1;
        if(bipartite(0))
            printf("YES\n");
        else
            printf("NO\n");
    }
    return 0;
}

时间: 2024-10-02 04:23:16

UVA11396-Claw Decomposition(二分图判定)的相关文章

UVa 11396 爪分解(二分图判定)

https://vjudge.net/problem/UVA-11396 题意: 给出n个结点的简单无向图,每个点的度数均为3.你的任务是判断能否把它分解成若干爪.每条边必须属于一个爪,但同一个点可以出现在多个爪里. 思路: 一个鸡爪当中,有一个中心点,即度为3的点,还有3个边缘点. 每条边都连接了一个中心点和一个边缘点,于是就是二分图判定. 1 #include<iostream> 2 #include<algorithm> 3 #include<cstring> 4

图论trainning-part-1 B. Claw Decomposition

B. Claw Decomposition Time Limit: 1000ms Memory Limit: 131072KB 64-bit integer IO format: %lld      Java class name: Main A claw is defined as a pointed curved nail on the end of each toe in birds, some reptiles, and some mammals. However, if you are

hdu 5285 wyh2000 and pupil(二分图判定)

对每两个不认识的人连一条边,则此题可转化为二分图判定(二分图可有多个). 如果有一部分图判定为不是二分图,则输出“Poor wyh”. 否则,分别累加每个二分图的最多的颜色数. #include <algorithm> #include <iostream> #include <cstring> #include <cstdio> #include <string> #include <stack> #include <cmat

二分图判定 nyoj1015(模板)

题目:点击打开链接nyoj1015 分析:题意很清楚,就是让判断一个图是不是二分图,思路当然就是染色法,首先给一个顶点然色,然后与它相邻的顶点全部染相反的颜色,如果过程中发现要染的点已经染色了,而且是和现在点相同的颜色的话,那么就说明不是一个二分图. 其实就是广搜模板 #include <cstdio> #include <cstring> #include <algorithm> #include <cmath> #include <vector&g

UVA 11080 - Place the Guards(二分图判定)

UVA 11080 - Place the Guards 题目链接 题意:一些城市.之间有道路相连,如今要安放警卫,警卫能看守到当前点周围的边,一条边仅仅能有一个警卫看守,问是否有方案,假设有最少放几个警卫 思路:二分图判定,判定过程记录下白点和黑点个数,小的就是要安放的个数,注意假设是0,那么应该是加1 代码: #include <cstdio> #include <cstring> #include <vector> using namespace std; con

二分图判定【图的搜索】

二分图判定 给定一个图,要给图上每个顶点染色,并且要使得相邻的顶点颜色不同.问是否能最多用2种颜色进行染色? 参考如下: Source Code: #include <iostream> #include <vector> using namespace std; vector<int> Edge[1010]; int colorArr[1010]; void initColorArr(int length){ for(int i=0;i<=length;++i)

HDU 2444 The Accomodation of Students(二分图判定+最大匹配)

Problem Description There are a group of students. Some of them may know each other, while others don't. For example, A and B know each other, B and C know each other. But this may not imply that A and C know each other. Now you are given all pairs o

编程算法 - 二分图判定 代码(C)

二分图判定 代码(C) 本文地址: http://blog.csdn.net/caroline_wendy 题目: 给定一个具有n个顶点的图. 要给图上每个顶点染色, 并且要使相邻的顶点颜色不同.  是否能最多用2种颜色进行染色. 没有重边和闭环. 即二分图问题. 使用深度优先搜索(dfs), 把顶点染成c, 然后相邻边染成-c. 如果相邻边被染色过, 且相同, 则图不是二分图; 如果所有边都被染色, 并且互不相同, 则是二分图. 进行多次搜索, 避免非连通图. 代码: /* * CppPrim

HDU 2444 The Accomodation of Students 二分图判定+最大匹配

题目来源:HDU 2444 The Accomodation of Students 题意:n个人是否可以分成2组 每组的人不能相互认识 就是二分图判定 可以分成2组 每组选一个2个人认识可以去一个双人间 最多可以有几组 思路:二分图判定+最大匹配 #include <cstdio> #include <cstring> #include <vector> using namespace std; const int maxn = 550; int vis[maxn];